
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

#include "ext.h"
#include "ext_obex.h"
						
// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
#pragma mark -
    
typedef struct _flop {
	t_object    ob;
    t_object    *patcher;
	void        *outlet;
	} t_flop;

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void *flop_new      (t_symbol *s, long argc, t_atom *argv);
void flop_free      (t_flop *x);

void flop_notify    (t_flop *x, t_symbol *s, t_symbol *msg, void *sender, void *data);
void flop_bang      (t_flop *x);

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------
		
static t_class *flop_class;

int main(void)
{	
	t_class	*c = NULL;
	
	c = class_new("flop", (method)flop_new, (method)flop_free, (long)(sizeof(t_flop)), 0L, A_GIMME, 0);
    class_addmethod(c, (method)flop_notify, "notify", A_CANT, 0); 
    class_addmethod(c, (method)flop_bang, "bang", 0);
	class_register(CLASS_BOX, c);
	flop_class = c;
		
	return 0;
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void *flop_new(t_symbol *s, long argc, t_atom *argv)
{
	t_flop *x = NULL;
	
	if (x = (t_flop *)object_alloc(flop_class)) {
        x->outlet = bangout((t_object *)x);
        object_obex_lookup(x, gensym("#P"), &x->patcher); 
    
        if (x->patcher) {
            object_attach_byptr_register(x, x->patcher, CLASS_NOBOX);
        }
    }	
	
	return x;
}

void flop_free(t_flop *x)
{ 
    if (x->patcher) {
        object_detach_byptr(x, x->patcher);
    }
    
    post("I am freed");
}

// -------------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------------

void flop_notify(t_flop *x, t_symbol *s, t_symbol *msg, void *sender, void *data)
{
    if (msg == gensym("free")) {
        post("Patcher will be freed !");
    }
}

void flop_bang(t_flop *x) 
{  
    outlet_bang(x->outlet);
}

// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x